# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`roundcube`](#roundcube): the main roundcube class
* [`roundcube::config`](#roundcube--config): roundcube configuration
* [`roundcube::db`](#roundcube--db): configure database
* [`roundcube::db::mysql`](#roundcube--db--mysql): crate a mysql db for roundcube
* [`roundcube::install`](#roundcube--install): install roundcube packages
* [`roundcube::vhost`](#roundcube--vhost): creates a vhost for roundcube
* [`roundcube::vhost::apache`](#roundcube--vhost--apache): internal class that installs an apache vhost Parameters are inherited from roundcube::vhost

### Defined types

* [`roundcube::plugin`](#roundcube--plugin): configures plugins

## Classes

### <a name="roundcube"></a>`roundcube`

the main roundcube class

#### Parameters

The following parameters are available in the `roundcube` class:

* [`ensure_database`](#-roundcube--ensure_database)
* [`ensure_vhost`](#-roundcube--ensure_vhost)

##### <a name="-roundcube--ensure_database"></a>`ensure_database`

Data type: `Boolean`

if true a database is created
Defaults to false

Default value: `false`

##### <a name="-roundcube--ensure_vhost"></a>`ensure_vhost`

Data type: `Boolean`

if true a virtualhost is created
Defaults to false

Default value: `false`

### <a name="roundcube--config"></a>`roundcube::config`

roundcube configuration

#### Parameters

The following parameters are available in the `roundcube::config` class:

* [`config_file`](#-roundcube--config--config_file)
* [`configs`](#-roundcube--config--configs)
* [`owner`](#-roundcube--config--owner)
* [`group`](#-roundcube--config--group)
* [`mode`](#-roundcube--config--mode)
* [`include_db_config`](#-roundcube--config--include_db_config)
* [`plugins`](#-roundcube--config--plugins)
* [`plugin_config_dir`](#-roundcube--config--plugin_config_dir)

##### <a name="-roundcube--config--config_file"></a>`config_file`

Data type: `String`

configuration file to use

Default value: `'/etc/roundcube/config.inc.php'`

##### <a name="-roundcube--config--configs"></a>`configs`

Data type: `Hash`

Hash of configuration variables to set.
Defaults to {}

Default value: `{}`

##### <a name="-roundcube--config--owner"></a>`owner`

Data type: `String`

owner of the config file

Default value: `'root'`

##### <a name="-roundcube--config--group"></a>`group`

Data type: `String`

group of the config file

Default value: `'www-data'`

##### <a name="-roundcube--config--mode"></a>`mode`

Data type: `String`

mode of the config file

Default value: `'0640'`

##### <a name="-roundcube--config--include_db_config"></a>`include_db_config`

Data type: `String`



Default value: `'/etc/roundcube/debian-db-roundcube.php'`

##### <a name="-roundcube--config--plugins"></a>`plugins`

Data type: `Hash`

plugings with configuration to generate
(uses create_resources for roundcube::plugin
 define, simplifies hiera usage !)

Default value: `{}`

##### <a name="-roundcube--config--plugin_config_dir"></a>`plugin_config_dir`

Data type: `String`

the default config directory to use for plugins
only used if roundcube::config::plugins parameter
is used

Default value: `'/etc/roundcube/plugins'`

### <a name="roundcube--db"></a>`roundcube::db`

configure database

#### Parameters

The following parameters are available in the `roundcube::db` class:

* [`dbpass`](#-roundcube--db--dbpass)
* [`dbtype`](#-roundcube--db--dbtype)
* [`dbname`](#-roundcube--db--dbname)
* [`dbuser`](#-roundcube--db--dbuser)
* [`basepath`](#-roundcube--db--basepath)
* [`dbport`](#-roundcube--db--dbport)
* [`host`](#-roundcube--db--host)
* [`dbconfig_inc`](#-roundcube--db--dbconfig_inc)

##### <a name="-roundcube--db--dbpass"></a>`dbpass`

Data type: `String`

password to connect to the database.

Default value: `'CHANGEME'`

##### <a name="-roundcube--db--dbtype"></a>`dbtype`

Data type: `String`

database type to use currently only mysql is
supported.
defaults to 'mysql'

Default value: `'mysql'`

##### <a name="-roundcube--db--dbname"></a>`dbname`

Data type: `String`

name of the database
defaults to: 'roundcube'

Default value: `'roundcube'`

##### <a name="-roundcube--db--dbuser"></a>`dbuser`

Data type: `String`

username to connect to the database.
defaults to: 'roundcube'

Default value: `'roundcube'`

##### <a name="-roundcube--db--basepath"></a>`basepath`

Data type: `Optional[String]`

basepath for database, defaults to undef

Default value: `undef`

##### <a name="-roundcube--db--dbport"></a>`dbport`

Data type: `String`

port to connect to db defaults to '3306' (mysql)

Default value: `'3306'`

##### <a name="-roundcube--db--host"></a>`host`

Data type: `String`

host that is allowed to connect
defaults to 'localhost'

Default value: `'localhost'`

##### <a name="-roundcube--db--dbconfig_inc"></a>`dbconfig_inc`

Data type: `String`

where to write the db config.
defaults to '/etc/roundcube/debian-db.php'
if you do not want to write, set it to ''

Default value: `'/etc/roundcube/debian-db.php'`

### <a name="roundcube--db--mysql"></a>`roundcube::db::mysql`

crate a mysql db for roundcube

#### Parameters

The following parameters are available in the `roundcube::db::mysql` class:

* [`dbname`](#-roundcube--db--mysql--dbname)
* [`dbuser`](#-roundcube--db--mysql--dbuser)
* [`dbpass`](#-roundcube--db--mysql--dbpass)
* [`host`](#-roundcube--db--mysql--host)

##### <a name="-roundcube--db--mysql--dbname"></a>`dbname`

Data type: `String`

the name of the database

Default value: `$roundcube::db::dbname`

##### <a name="-roundcube--db--mysql--dbuser"></a>`dbuser`

Data type: `String`

db user

Default value: `$roundcube::db::dbuser`

##### <a name="-roundcube--db--mysql--dbpass"></a>`dbpass`

Data type: `String`

password for the user

Default value: `$roundcube::db::dbpass`

##### <a name="-roundcube--db--mysql--host"></a>`host`

Data type: `String`

database host

Default value: `$roundcube::db::host`

### <a name="roundcube--install"></a>`roundcube::install`

install roundcube packages

#### Parameters

The following parameters are available in the `roundcube::install` class:

* [`packages`](#-roundcube--install--packages)
* [`package_ensure`](#-roundcube--install--package_ensure)

##### <a name="-roundcube--install--packages"></a>`packages`

Data type: `Array`

the packages to install

Default value: `['roundcube']`

##### <a name="-roundcube--install--package_ensure"></a>`package_ensure`

Data type: `String`

what to ensure for packages

Default value: `'installed'`

### <a name="roundcube--vhost"></a>`roundcube::vhost`

This class chooses the type of vhost
to run webserver

#### Parameters

The following parameters are available in the `roundcube::vhost` class:

* [`vhosttype`](#-roundcube--vhost--vhosttype)
* [`servername`](#-roundcube--vhost--servername)
* [`serveraliases`](#-roundcube--vhost--serveraliases)
* [`docroot`](#-roundcube--vhost--docroot)
* [`ssl`](#-roundcube--vhost--ssl)
* [`ssl_cert`](#-roundcube--vhost--ssl_cert)
* [`ssl_key`](#-roundcube--vhost--ssl_key)
* [`ssl_chain`](#-roundcube--vhost--ssl_chain)
* [`redirect_to_ssl`](#-roundcube--vhost--redirect_to_ssl)
* [`create_resources`](#-roundcube--vhost--create_resources)

##### <a name="-roundcube--vhost--vhosttype"></a>`vhosttype`

Data type: `String`

type of vhost to run. currently only apache supported (default)

Default value: `'apache'`

##### <a name="-roundcube--vhost--servername"></a>`servername`

Data type: `String`

Servername (defaults to $::fqdn)

Default value: `$facts['networking']['fqdn']`

##### <a name="-roundcube--vhost--serveraliases"></a>`serveraliases`

Data type: `Array`

Array of Serveraliasess to listen to (default [])

Default value: `[]`

##### <a name="-roundcube--vhost--docroot"></a>`docroot`

Data type: `Stdlib::Absolutepath`

Document root

Default value: `'/var/lib/roundcube'`

##### <a name="-roundcube--vhost--ssl"></a>`ssl`

Data type: `Boolean`

If true, use ssl (defaults to false)
If true, you also need to set cert, key and chain.

Default value: `false`

##### <a name="-roundcube--vhost--ssl_cert"></a>`ssl_cert`

Data type: `Optional[Stdlib::Absolutepath]`

ssl cert to use

Default value: `undef`

##### <a name="-roundcube--vhost--ssl_key"></a>`ssl_key`

Data type: `Optional[Stdlib::Absolutepath]`

ssl key to use

Default value: `undef`

##### <a name="-roundcube--vhost--ssl_chain"></a>`ssl_chain`

Data type: `Optional[Stdlib::Absolutepath]`

ssl chain to use

Default value: `undef`

##### <a name="-roundcube--vhost--redirect_to_ssl"></a>`redirect_to_ssl`

Data type: `Boolean`

if true, redirects all non https requests to https
defaults to true.

Default value: `true`

##### <a name="-roundcube--vhost--create_resources"></a>`create_resources`

Data type: `Hash`

a Hash of Hashes to create additional resources eg. to
retrieve a certificate.
Defaults to {} (do not create any additional resources)
Example (hiera):

roundcube::vhost::create_resources:
    sslcert::get_cert:
        get_my_roundcube_cert:
          private_key_path: '/etc/roundcube/ssl/key.pem'
          cert_path: '/etc/roundcube/ssl/cert.pem'

Will result in  executing:

sslcert::get_cert{'get_my_roundcube_cert':
  private_key_path => '/etc/roundcube/ssl/key.pem'
  cert_path        => '/etc/roundcube/ssl/cert.pem'
}

Default value: `{}`

### <a name="roundcube--vhost--apache"></a>`roundcube::vhost::apache`

internal class that installs an apache vhost
Parameters are inherited from roundcube::vhost

#### Parameters

The following parameters are available in the `roundcube::vhost::apache` class:

* [`servername`](#-roundcube--vhost--apache--servername)
* [`serveraliases`](#-roundcube--vhost--apache--serveraliases)
* [`docroot`](#-roundcube--vhost--apache--docroot)
* [`apache_vhost`](#-roundcube--vhost--apache--apache_vhost)
* [`ssl`](#-roundcube--vhost--apache--ssl)
* [`ssl_cert`](#-roundcube--vhost--apache--ssl_cert)
* [`ssl_key`](#-roundcube--vhost--apache--ssl_key)
* [`ssl_chain`](#-roundcube--vhost--apache--ssl_chain)
* [`redirect_to_ssl`](#-roundcube--vhost--apache--redirect_to_ssl)

##### <a name="-roundcube--vhost--apache--servername"></a>`servername`

Data type: `String`



Default value: `$roundcube::vhost::servername`

##### <a name="-roundcube--vhost--apache--serveraliases"></a>`serveraliases`

Data type: `Array`



Default value: `$roundcube::vhost::serveraliases`

##### <a name="-roundcube--vhost--apache--docroot"></a>`docroot`

Data type: `Stdlib::Absolutepath`



Default value: `$roundcube::vhost::docroot`

##### <a name="-roundcube--vhost--apache--apache_vhost"></a>`apache_vhost`

Data type: `Hash`



Default value: `{}`

##### <a name="-roundcube--vhost--apache--ssl"></a>`ssl`

Data type: `Boolean`



Default value: `$roundcube::vhost::ssl`

##### <a name="-roundcube--vhost--apache--ssl_cert"></a>`ssl_cert`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `$roundcube::vhost::ssl_cert`

##### <a name="-roundcube--vhost--apache--ssl_key"></a>`ssl_key`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `$roundcube::vhost::ssl_key`

##### <a name="-roundcube--vhost--apache--ssl_chain"></a>`ssl_chain`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `$roundcube::vhost::ssl_chain`

##### <a name="-roundcube--vhost--apache--redirect_to_ssl"></a>`redirect_to_ssl`

Data type: `Boolean`



Default value: `$roundcube::vhost::redirect_to_ssl`

## Defined types

### <a name="roundcube--plugin"></a>`roundcube::plugin`

configures plugins

#### Parameters

The following parameters are available in the `roundcube::plugin` defined type:

* [`plugin_config_dir`](#-roundcube--plugin--plugin_config_dir)
* [`configs`](#-roundcube--plugin--configs)
* [`plugin_name`](#-roundcube--plugin--plugin_name)
* [`owner`](#-roundcube--plugin--owner)
* [`group`](#-roundcube--plugin--group)
* [`mode`](#-roundcube--plugin--mode)

##### <a name="-roundcube--plugin--plugin_config_dir"></a>`plugin_config_dir`

Data type: `String`

directory

##### <a name="-roundcube--plugin--configs"></a>`configs`

Data type: `Hash`

the configurations

Default value: `{}`

##### <a name="-roundcube--plugin--plugin_name"></a>`plugin_name`

Data type: `String`

name of the plugin

Default value: `$title`

##### <a name="-roundcube--plugin--owner"></a>`owner`

Data type: `String`

owner of the config file

Default value: `'root'`

##### <a name="-roundcube--plugin--group"></a>`group`

Data type: `String`

group of the config file

Default value: `'root'`

##### <a name="-roundcube--plugin--mode"></a>`mode`

Data type: `String`

mode of the config file

Default value: `'0644'`

